diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/sta-wifi-mac.cc ns-3.45/src/wifi/model/sta-wifi-mac.cc
--- ns-3.44/src/wifi/model/sta-wifi-mac.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/sta-wifi-mac.cc	2025-06-01 20:34:45.625702100 -0700
@@ -2070,15 +2103,23 @@
 {
     NS_LOG_FUNCTION(this << phy << linkId << delay.As(Time::US));
 
-    // If the PHY is switching channel to operate on another link, then it is no longer operating
-    // on the current link. If any link (other than the current link) points to the PHY that is
-    // switching channel, reset the phy pointer of the link
+    // if the PHY that is starting a channel switch was operating on a link (i.e., there is a link,
+    // other than the new link, that points to the PHY), then it is no longer operating on that
+    // link and we have to reset the phy pointer of the link.
     for (auto& [id, link] : GetLinks())
     {
         if (link->phy == phy && id != linkId)
         {
+            // we do not get here if the PHY is not operating on any link, which happens if:
+            // - PHY is an aux PHY to reconnect to its link
+            // - PHY is an aux PHY that is starting switching to the link previously occupied by the
+            //   main PHY (because the main PHY is now operating on the aux PHY link)
+            // - PHY is the main PHY that completed the channel switch but connecting it to the link
+            //   was postponed until now (e.g. because the aux PHY on the link was receiving an ICF)
+            // - PHY is the main PHY that was switching, the switch was interrupted and it is
+            //   now starting switching to another link
             link->phy = nullptr;
-            m_emlsrLinkSwitchLogger(id, nullptr);
+            m_emlsrLinkSwitchLogger(id, phy, false);
         }
     }
 
@@ -2101,7 +2142,7 @@
         // Connect the station manager on the new link to the given PHY
         newLink.stationManager->SetupPhy(phy);
         // log link switch
-        m_emlsrLinkSwitchLogger(linkId, phy);
+        m_emlsrLinkSwitchLogger(linkId, phy, true);
     };
 
     // cancel any pending event for the given PHY to switch link
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/sta-wifi-mac.h ns-3.45/src/wifi/model/sta-wifi-mac.h
--- ns-3.44/src/wifi/model/sta-wifi-mac.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/sta-wifi-mac.h	2025-06-01 20:34:45.625702100 -0700
@@ -34,6 +34,18 @@
 /**
  * @ingroup wifi
  *
+ * Type of association performed by this device (provided that it is supported by the standard
+ * configured for this device).
+ */
+enum class WifiAssocType : uint8_t
+{
+    LEGACY = 0,
+    ML_SETUP
+};
+
+/**
+ * @ingroup wifi
+ *
  * Scan type (active or passive)
  */
 enum class WifiScanType : uint8_t
@@ -137,10 +149,6 @@
     friend class ::MultiLinkOperationsTestBase;
     friend class ::ProbeExchTest;
 
-    /// type of the management frames used to get info about APs
-    using MgtFrameType =
-        std::variant<MgtBeaconHeader, MgtProbeResponseHeader, MgtAssocResponseHeader>;
-
     /**
      * Struct to hold information regarding observed AP through
      * active/passive scanning
@@ -267,6 +275,9 @@
      */
     uint16_t GetAssociationId() const;
 
+    /// @return the type of association procedure performed by this device
+    WifiAssocType GetAssocType() const;
+
     /**
      * Enable or disable Power Save mode on the given link.
      *
@@ -316,7 +327,8 @@
      * Notify that the given PHY switched channel to operate on another EMLSR link.
      *
      * @param phy the given PHY
-     * @param linkId the ID of the EMLSR link on which the given PHY is operating
+     * @param linkId the ID of the EMLSR link on which the given PHY operates after
+     *               the channel switch
      * @param delay the delay after which the channel switch will be completed
      */
     void NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy, uint8_t linkId, Time delay);
@@ -452,19 +464,27 @@
     void ReceiveAssocResp(Ptr<const WifiMpdu> mpdu, uint8_t linkId);
 
     /**
-     * Update associated AP's information from the given management frame (Beacon,
-     * Probe Response or Association Response). If STA is not associated, this
-     * information will be used for the association process.
+     * Update operations information from the given management frame.
+     *
+     * @param frame the body of the given management frame
+     * @param addr MAC address of the sender
+     * @param linkId ID of the link the management frame was received over
+     */
+    void RecordOperations(const MgtFrameType& frame, const Mac48Address& addr, uint8_t linkId);
+
+    /**
+     * Update operational settings based on associated AP's information provided by the given
+     * management frame (Beacon, Probe Response or Association Response).
      *
      * @param frame the body of the given management frame
      * @param apAddr MAC address of the AP
      * @param bssid MAC address of BSSID
      * @param linkId ID of the link the management frame was received over
      */
-    void UpdateApInfo(const MgtFrameType& frame,
-                      const Mac48Address& apAddr,
-                      const Mac48Address& bssid,
-                      uint8_t linkId);
+    void ApplyOperationalSettings(const MgtFrameType& frame,
+                                  const Mac48Address& apAddr,
+                                  const Mac48Address& bssid,
+                                  uint8_t linkId);
 
     /**
      * Get the (Re)Association Request frame to send on a given link. The returned frame
@@ -633,6 +653,7 @@
     MacState m_state;                             ///< MAC state
     uint16_t m_aid;                               ///< Association AID
     Ptr<WifiAssocManager> m_assocManager;         ///< Association Manager
+    WifiAssocType m_assocType;                    ///< type of association
     Ptr<EmlsrManager> m_emlsrManager;             ///< EMLSR Manager
     Time m_waitBeaconTimeout;                     ///< wait beacon timeout
     Time m_probeRequestTimeout;                   ///< probe request timeout
@@ -653,12 +674,13 @@
     /// store the UL TID-to-Link Mapping included in the Association Request frame
     WifiTidLinkMapping m_ulTidLinkMappingInAssocReq;
 
-    TracedCallback<Mac48Address> m_assocLogger;                    ///< association logger
-    TracedCallback<uint8_t, Mac48Address> m_setupCompleted;        ///< link setup completed logger
-    TracedCallback<Mac48Address> m_deAssocLogger;                  ///< disassociation logger
-    TracedCallback<Time> m_beaconArrival;                          ///< beacon arrival logger
-    TracedCallback<ApInfo> m_beaconInfo;                           ///< beacon info logger
-    TracedCallback<uint8_t, Ptr<WifiPhy>> m_emlsrLinkSwitchLogger; ///< EMLSR link switch logger
+    TracedCallback<Mac48Address> m_assocLogger;             ///< association logger
+    TracedCallback<uint8_t, Mac48Address> m_setupCompleted; ///< link setup completed logger
+    TracedCallback<Mac48Address> m_deAssocLogger;           ///< disassociation logger
+    TracedCallback<Time> m_beaconArrival;                   ///< beacon arrival logger
+    TracedCallback<ApInfo> m_beaconInfo;                    ///< beacon info logger
+    TracedCallback<uint8_t, Ptr<WifiPhy>, bool>
+        m_emlsrLinkSwitchLogger; ///< EMLSR link switch logger
 
     /// TracedCallback signature for link setup completed/canceled events
     using LinkSetupCallback = void (*)(uint8_t /* link ID */, Mac48Address /* AP address */);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/supported-rates.cc ns-3.45/src/wifi/model/supported-rates.cc
--- ns-3.44/src/wifi/model/supported-rates.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/supported-rates.cc	2025-06-01 20:34:45.625702100 -0700
@@ -30,7 +30,7 @@
 void
 SupportedRates::Print(std::ostream& os) const
 {
-    os << "rates=[";
+    os << "Supported Rates=[";
     for (std::size_t i = 0; i < m_rates.size(); i++)
     {
         if ((m_rates[i] & 0x80) > 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/supported-rates.h ns-3.45/src/wifi/model/supported-rates.h
--- ns-3.44/src/wifi/model/supported-rates.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/supported-rates.h	2025-06-01 20:34:45.625702100 -0700
@@ -21,7 +21,7 @@
  * @brief The Supported Rates Information Element
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise the Supported
+ * This class knows how to serialize and deserialize the Supported
  * Rates Element that holds the first 8 (non-HT) supported rates.
  *
  * The \c ExtendedSupportedRatesIE class deals with rates beyond the first 8.
@@ -57,7 +57,7 @@
  * @brief The Extended Supported Rates Information Element
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise the Extended
+ * This class knows how to serialize and deserialize the Extended
  * Supported Rates Element that holds (non-HT) rates beyond the 8 that
  * the original Supported Rates element can carry.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/tim.cc ns-3.45/src/wifi/model/tim.cc
--- ns-3.44/src/wifi/model/tim.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/tim.cc	2025-06-01 20:34:45.625702100 -0700
@@ -8,6 +8,8 @@
 
 #include "tim.h"
 
+#include "wifi-constants.h"
+
 #include <algorithm>
 #include <cstdint>
 
@@ -37,7 +39,7 @@
 void
 Tim::AddAid(uint16_t aid)
 {
-    NS_ABORT_IF(aid > 2007);
+    NS_ABORT_IF(aid > MAX_AID);
 
     m_aidValues.insert(aid);
 }
@@ -205,9 +207,8 @@
 void
 Tim::Print(std::ostream& os) const
 {
-    os << "DTIM Count: " << +m_dtimCount << ", "
-       << "DTIM Period: " << +m_dtimPeriod << ", "
-       << "Has Multicast Pending: " << m_hasMulticastPending << ", AID values:";
+    os << "TIM=[DTIM Count: " << +m_dtimCount << ", DTIM Period: " << +m_dtimPeriod
+       << ", Has Multicast Pending: " << m_hasMulticastPending << ", AID values: ";
     for (uint16_t aid = 0; aid < 2008; ++aid)
     {
         if (HasAid(aid))
@@ -215,6 +216,7 @@
             os << aid << " ";
         }
     }
+    os << "]";
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/txop.cc ns-3.45/src/wifi/model/txop.cc
--- ns-3.44/src/wifi/model/txop.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/txop.cc	2025-06-01 20:34:45.625702100 -0700
@@ -65,16 +65,18 @@
                                           "AC_BEACON",
                                           AC_UNDEF,
                                           "AC_UNDEF"))
-            .AddAttribute("MinCw",
-                          "The minimum value of the contention window (just for the first link, "
-                          "in case of 11be multi-link devices).",
-                          TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
-                          UintegerValue(15),
-                          MakeUintegerAccessor((void(Txop::*)(uint32_t)) & Txop::SetMinCw,
-                                               (uint32_t(Txop::*)() const) & Txop::GetMinCw),
-                          MakeUintegerChecker<uint32_t>(),
-                          TypeId::SupportLevel::OBSOLETE,
-                          "Use MinCws attribute instead of MinCw")
+            // NS_DEPRECATED_3_42
+            .AddAttribute(
+                "MinCw",
+                "The minimum value of the contention window (just for the first link, "
+                "in case of 11be multi-link devices).",
+                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
+                UintegerValue(15),
+                MakeUintegerAccessor(static_cast<void (Txop::*)(uint32_t)>(&Txop::SetMinCw),
+                                     static_cast<uint32_t (Txop::*)() const>(&Txop::GetMinCw)),
+                MakeUintegerChecker<uint32_t>(),
+                TypeId::SupportLevel::OBSOLETE,
+                "Use MinCws attribute instead of MinCw")
             .AddAttribute(
                 "MinCws",
                 "The minimum values of the contention window for all the links (sorted in "
@@ -85,16 +87,18 @@
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetMinCws, &Txop::GetMinCws),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint32_t>()))
-            .AddAttribute("MaxCw",
-                          "The maximum value of the contention window (just for the first link, "
-                          "in case of 11be multi-link devices).",
-                          TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
-                          UintegerValue(1023),
-                          MakeUintegerAccessor((void(Txop::*)(uint32_t)) & Txop::SetMaxCw,
-                                               (uint32_t(Txop::*)() const) & Txop::GetMaxCw),
-                          MakeUintegerChecker<uint32_t>(),
-                          TypeId::SupportLevel::OBSOLETE,
-                          "Use MaxCws attribute instead of MaxCw")
+            // NS_DEPRECATED_3_42
+            .AddAttribute(
+                "MaxCw",
+                "The maximum value of the contention window (just for the first link, "
+                "in case of 11be multi-link devices).",
+                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
+                UintegerValue(1023),
+                MakeUintegerAccessor(static_cast<void (Txop::*)(uint32_t)>(&Txop::SetMaxCw),
+                                     static_cast<uint32_t (Txop::*)() const>(&Txop::GetMaxCw)),
+                MakeUintegerChecker<uint32_t>(),
+                TypeId::SupportLevel::OBSOLETE,
+                "Use MaxCws attribute instead of MaxCw")
             .AddAttribute(
                 "MaxCws",
                 "The maximum values of the contention window for all the links (sorted in "
@@ -105,14 +109,15 @@
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetMaxCws, &Txop::GetMaxCws),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint32_t>()))
+            // NS_DEPRECATED_3_42
             .AddAttribute(
                 "Aifsn",
                 "The AIFSN: the default value conforms to non-QOS (just for the first link, "
                 "in case of 11be multi-link devices).",
                 TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
                 UintegerValue(2),
-                MakeUintegerAccessor((void(Txop::*)(uint8_t)) & Txop::SetAifsn,
-                                     (uint8_t(Txop::*)() const) & Txop::GetAifsn),
+                MakeUintegerAccessor(static_cast<void (Txop::*)(uint8_t)>(&Txop::SetAifsn),
+                                     static_cast<uint8_t (Txop::*)() const>(&Txop::GetAifsn)),
                 MakeUintegerChecker<uint8_t>(),
                 TypeId::SupportLevel::OBSOLETE,
                 "Use Aifsns attribute instead of Aifsn")
@@ -126,16 +131,18 @@
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetAifsns, &Txop::GetAifsns),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()))
-            .AddAttribute("TxopLimit",
-                          "The TXOP limit: the default value conforms to non-QoS "
-                          "(just for the first link, in case of 11be multi-link devices).",
-                          TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
-                          TimeValue(MilliSeconds(0)),
-                          MakeTimeAccessor((void(Txop::*)(Time)) & Txop::SetTxopLimit,
-                                           (Time(Txop::*)() const) & Txop::GetTxopLimit),
-                          MakeTimeChecker(),
-                          TypeId::SupportLevel::OBSOLETE,
-                          "Use TxopLimits attribute instead of TxopLimit")
+            // NS_DEPRECATED_3_42
+            .AddAttribute(
+                "TxopLimit",
+                "The TXOP limit: the default value conforms to non-QoS "
+                "(just for the first link, in case of 11be multi-link devices).",
+                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
+                TimeValue(MilliSeconds(0)),
+                MakeTimeAccessor(static_cast<void (Txop::*)(Time)>(&Txop::SetTxopLimit),
+                                 static_cast<Time (Txop::*)() const>(&Txop::GetTxopLimit)),
+                MakeTimeChecker(),
+                TypeId::SupportLevel::OBSOLETE,
+                "Use TxopLimits attribute instead of TxopLimit")
             .AddAttribute(
                 "TxopLimits",
                 "The values of TXOP limit for all the links (sorted in increasing order "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/vht/vht-capabilities.cc ns-3.45/src/wifi/model/vht/vht-capabilities.cc
--- ns-3.44/src/wifi/model/vht/vht-capabilities.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/vht/vht-capabilities.cc	2025-06-01 20:34:45.626702300 -0700
@@ -55,7 +55,10 @@
 void
 VhtCapabilities::Print(std::ostream& os) const
 {
-    os << "VHT Capabilities=" << GetVhtCapabilitiesInfo() << "|" << GetSupportedMcsAndNssSet();
+    os << "VHT Capabilities=[Supported Channel Width Set: " << +m_supportedChannelWidthSet
+       << ", SGI 80 MHz: " << +m_shortGuardIntervalFor80Mhz
+       << ", SGI 160 MHz: " << +m_shortGuardIntervalFor160Mhz
+       << ", Max MPDU Length: " << m_maxMpduLength << "]";
 }
 
 uint16_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/vht/vht-configuration.cc ns-3.45/src/wifi/model/vht/vht-configuration.cc
--- ns-3.44/src/wifi/model/vht/vht-configuration.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/vht/vht-configuration.cc	2025-06-01 20:34:45.626702300 -0700
@@ -39,11 +39,15 @@
             .SetParent<Object>()
             .SetGroupName("Wifi")
             .AddConstructor<VhtConfiguration>()
+            // NS_DEPRECATED_3_45
             .AddAttribute("Support160MHzOperation",
                           "Whether or not 160 MHz operation is to be supported.",
                           BooleanValue(true),
                           MakeBooleanAccessor(&VhtConfiguration::m_160MHzSupported),
-                          MakeBooleanChecker())
+                          MakeBooleanChecker(),
+                          TypeId::SupportLevel::OBSOLETE,
+                          "Set an initial channel via WifiPhy::ChannelSettings whose width "
+                          "corresponds to the maximum desired width instead")
             .AddAttribute("SecondaryCcaSensitivityThresholds",
                           "Tuple {threshold for 20MHz PPDUs, threshold for 40MHz PPDUs, threshold "
                           "for 80MHz PPDUs} "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/vht/vht-configuration.h ns-3.45/src/wifi/model/vht/vht-configuration.h
--- ns-3.44/src/wifi/model/vht/vht-configuration.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/vht/vht-configuration.h	2025-06-01 20:34:45.626702300 -0700
@@ -45,14 +45,14 @@
      * @param enable true if 20 MHz, 40 MHz, 80 MHz and 160 MHz operation is to be supported,
      *               false if 20 MHz, 40 MHz and 80 MHz operation is to be supported
      */
-    NS_DEPRECATED_3_44("Set the m_160MHzSupported member variable instead")
+    NS_DEPRECATED_3_44("Set the ChannelSettings of the WifiPhy instead")
     void Set160MHzOperationSupported(bool enable);
 
     /**
      * @return true if 20 MHz, 40 MHz, 80 MHz and 160 MHz operation is supported,
      *         false if 20 MHz, 40 MHz and 80 MHz operation is supported
      */
-    NS_DEPRECATED_3_44("Get the m_160MHzSupported member variable instead")
+    NS_DEPRECATED_3_44("Use WifiPhy::GetChannelWidth instead")
     bool Get160MHzOperationSupported() const;
 
     using SecondaryCcaSensitivityThresholds =
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/vht/vht-operation.cc ns-3.45/src/wifi/model/vht/vht-operation.cc
--- ns-3.44/src/wifi/model/vht/vht-operation.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/vht/vht-operation.cc	2025-06-01 20:34:45.626702300 -0700
@@ -28,8 +28,10 @@
 void
 VhtOperation::Print(std::ostream& os) const
 {
-    os << "VHT Operation=" << +GetChannelWidth() << "|" << +GetChannelCenterFrequencySegment0()
-       << "|" << +GetChannelCenterFrequencySegment1() << "|" << GetBasicVhtMcsAndNssSet();
+    os << "VHT Operation=[Channel Width: " << +m_channelWidth
+       << ", Channel Center Frequency Segment 0: " << +m_channelCenterFrequencySegment0
+       << ", Channel Center Frequency Segment 1: " << +m_channelCenterFrequencySegment1
+       << ", Basic VHT-MCS and NSS Set: " << m_basicVhtMcsAndNssSet << "]";
 }
 
 uint16_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/vht/vht-operation.h ns-3.45/src/wifi/model/vht/vht-operation.h
--- ns-3.44/src/wifi/model/vht/vht-operation.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/vht/vht-operation.h	2025-06-01 20:34:45.626702300 -0700
@@ -18,7 +18,7 @@
  * @brief The VHT Operation Information Element
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise
+ * This class knows how to serialize and deserialize
  * the VHT Operation Information Element
  */
 class VhtOperation : public WifiInformationElement
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/vht/vht-phy.cc ns-3.45/src/wifi/model/vht/vht-phy.cc
--- ns-3.44/src/wifi/model/vht/vht-phy.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/vht/vht-phy.cc	2025-06-01 20:34:45.626702300 -0700
@@ -68,19 +68,9 @@
 // clang-format on
 
 /**
- * @brief map a given channel list type to the corresponding scaling factor
- */
-const std::map<WifiChannelListType, dBm_u> channelTypeToScalingFactor{
-    {WIFI_CHANLIST_PRIMARY, dBm_u{0.0}},
-    {WIFI_CHANLIST_SECONDARY, dBm_u{0.0}},
-    {WIFI_CHANLIST_SECONDARY40, dBm_u{3.0}},
-    {WIFI_CHANLIST_SECONDARY80, dBm_u{6.0}},
-};
-
-/**
  * @brief map a given secondary channel width to its channel list type
  */
-const std::map<MHz_u, WifiChannelListType> secondaryChannels{
+const std::map<MHz_u, WifiChannelListType> vhtSecondaryChannels{
     {MHz_u{20}, WIFI_CHANLIST_SECONDARY},
     {MHz_u{40}, WIFI_CHANLIST_SECONDARY40},
     {MHz_u{80}, WIFI_CHANLIST_SECONDARY80},
@@ -573,85 +563,10 @@
     }
 }
 
-PhyEntity::CcaIndication
-VhtPhy::GetCcaIndication(const Ptr<const WifiPpdu> ppdu)
+const std::map<MHz_u, WifiChannelListType>&
+VhtPhy::GetCcaSecondaryChannels() const
 {
-    if (m_wifiPhy->GetChannelWidth() < 80)
-    {
-        return HtPhy::GetCcaIndication(ppdu);
-    }
-
-    auto ccaThreshold = GetCcaThreshold(ppdu, WIFI_CHANLIST_PRIMARY);
-    auto delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, GetPrimaryBand(20));
-    if (delayUntilCcaEnd.IsStrictlyPositive())
-    {
-        return std::make_pair(
-            delayUntilCcaEnd,
-            WIFI_CHANLIST_PRIMARY); // if Primary is busy, ignore CCA for Secondary
-    }
-
-    if (ppdu)
-    {
-        const MHz_u primaryWidth{20};
-        const MHz_u p20MinFreq =
-            m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(primaryWidth) -
-            (primaryWidth / 2);
-        const MHz_u p20MaxFreq =
-            m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(primaryWidth) +
-            (primaryWidth / 2);
-        if (ppdu->DoesOverlapChannel(p20MinFreq, p20MaxFreq))
-        {
-            /*
-             * PPDU occupies primary 20 MHz channel, hence we skip CCA sensitivity rules
-             * for signals not occupying the primary 20 MHz channel.
-             */
-            return std::nullopt;
-        }
-    }
-
-    std::vector<MHz_u> secondaryWidthsToCheck;
-    if (ppdu)
-    {
-        for (const auto& secondaryChannel : secondaryChannels)
-        {
-            const auto secondaryWidth = secondaryChannel.first;
-            const MHz_u secondaryMinFreq =
-                m_wifiPhy->GetOperatingChannel().GetSecondaryChannelCenterFrequency(
-                    secondaryWidth) -
-                (secondaryWidth / 2);
-            const MHz_u secondaryMaxFreq =
-                m_wifiPhy->GetOperatingChannel().GetSecondaryChannelCenterFrequency(
-                    secondaryWidth) +
-                (secondaryWidth / 2);
-            if ((m_wifiPhy->GetChannelWidth() > secondaryWidth) &&
-                ppdu->DoesOverlapChannel(secondaryMinFreq, secondaryMaxFreq))
-            {
-                secondaryWidthsToCheck.push_back(secondaryWidth);
-            }
-        }
-    }
-    else
-    {
-        secondaryWidthsToCheck.push_back(20);
-        secondaryWidthsToCheck.push_back(40);
-        if (m_wifiPhy->GetChannelWidth() > 80)
-        {
-            secondaryWidthsToCheck.push_back(80);
-        }
-    }
-
-    for (auto secondaryWidth : secondaryWidthsToCheck)
-    {
-        auto channelType = secondaryChannels.at(secondaryWidth);
-        ccaThreshold = GetCcaThreshold(ppdu, channelType);
-        delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, GetSecondaryBand(secondaryWidth));
-        if (delayUntilCcaEnd.IsStrictlyPositive())
-        {
-            return std::make_pair(delayUntilCcaEnd, channelType);
-        }
-    }
-
-    return std::nullopt;
+    return vhtSecondaryChannels;
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/vht/vht-phy.h ns-3.45/src/wifi/model/vht/vht-phy.h
--- ns-3.44/src/wifi/model/vht/vht-phy.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/vht/vht-phy.h	2025-06-01 20:34:45.626702300 -0700
@@ -267,7 +267,7 @@
     PhyFieldRxStatus DoEndReceiveField(WifiPpduField field, Ptr<Event> event) override;
     bool IsAllConfigSupported(WifiPpduField field, Ptr<const WifiPpdu> ppdu) const override;
     uint32_t GetMaxPsduSize() const override;
-    CcaIndication GetCcaIndication(const Ptr<const WifiPpdu> ppdu) override;
+    const std::map<MHz_u, WifiChannelListType>& GetCcaSecondaryChannels() const override;
 
     /**
      * End receiving the SIG-A or SIG-B, perform VHT-specific actions, and
@@ -347,7 +347,7 @@
     static const NesExceptionMap m_exceptionsMap; //!< exception map for number of BCC encoders
                                                   //!< (extracted from VHT-MCS tables)
     static const PpduFormats m_vhtPpduFormats;    //!< VHT PPDU formats
-};                                                // class VhtPhy
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/vht/vht-ppdu.h ns-3.45/src/wifi/model/vht/vht-ppdu.h
--- ns-3.44/src/wifi/model/vht/vht-ppdu.h	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/vht/vht-ppdu.h	2025-06-01 20:34:45.626702300 -0700
@@ -124,7 +124,9 @@
 
         /// This is used to decide whether MU SIG-B should be added or not
         bool m_mu;
-    }; // class VhtSigHeader
+
+        // end of class VhtSigHeader
+    };
 
     /**
      * Create a VHT PPDU.
@@ -187,7 +189,7 @@
                                    const VhtSigHeader& vhtSig) const;
 
     VhtSigHeader m_vhtSig; //!< the VHT-SIG PHY header
-};                         // class VhtPpdu
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-assoc-manager.cc ns-3.45/src/wifi/model/wifi-assoc-manager.cc
--- ns-3.44/src/wifi/model/wifi-assoc-manager.cc	2025-03-09 16:55:49.799372700 -0700
+++ ns-3.45/src/wifi/model/wifi-assoc-manager.cc	2025-06-01 20:34:45.626702300 -0700
@@ -10,8 +10,10 @@
 #include "wifi-assoc-manager.h"
 
 #include "sta-wifi-mac.h"
+#include "wifi-phy.h"
 
 #include "ns3/attribute-container.h"
+#include "ns3/boolean.h"
 #include "ns3/eht-configuration.h"
 #include "ns3/enum.h"
 #include "ns3/log.h"
@@ -67,7 +69,15 @@
                 "set are processed. An empty set is equivalent to the set of all links.",
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&WifiAssocManager::m_allowedLinks),
-                MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()));
+                MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()))
+            .AddAttribute("AllowAssocAllChannelWidths",
+                          "If set to true, it bypasses the check on channel width compatibility "
+                          "with the candidate AP. A channel width is compatible if the STA can "
+                          "advertise it to the AP, or AP operates on a channel width that is equal "
+                          "or lower than that channel width.",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&WifiAssocManager::m_allowAssocAllChannelWidths),
+                          MakeBooleanChecker());
     return tid;
 }
 
@@ -236,6 +246,10 @@
         m_apListIt.erase(bestAp.m_bssid);
     } while (!CanBeReturned(bestAp));
 
+    NS_ABORT_MSG_IF(!m_allowAssocAllChannelWidths && !IsChannelWidthCompatible(bestAp),
+                    "Channel width of STA is not part of the channel width set that can be "
+                    "advertised to the AP");
+
     m_mac->ScanningTimeout(std::move(bestAp));
 }
 
@@ -250,7 +264,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_mac->GetNLinks() == 1 || GetSortedList().empty())
+    if (m_mac->GetAssocType() == WifiAssocType::LEGACY || GetSortedList().empty())
     {
         return false;
     }
@@ -361,4 +375,14 @@
     return apList;
 }
 
+bool
+WifiAssocManager::IsChannelWidthCompatible(const StaWifiMac::ApInfo& apInfo) const
+{
+    auto phy = m_mac->GetWifiPhy(apInfo.m_linkId);
+    return GetSupportedChannelWidthSet(phy->GetStandard(), apInfo.m_channel.band)
+               .contains(phy->GetChannelWidth()) ||
+           (phy->GetChannelWidth() >= m_mac->GetWifiRemoteStationManager(apInfo.m_linkId)
+                                          ->GetChannelWidthSupported(apInfo.m_bssid));
+}
+
 } // namespace ns3
